unit uSubsystemCotacaoDolar;

interface

type
  { Subsystem }
  TSubsystemCotacaoDolar = class
  public
    function ConsultarCotacaoDolar: real;
  end;

implementation

uses
  SysUtils, uWSDL_BCB, SOAPHTTPClient, Windows;

{ TSubsystemCotacaoDolar }

function TSubsystemCotacaoDolar.ConsultarCotacaoDolar: real;
var
  WebServiceCotacao: FachadaWSSGS;
  HTTPRIO: THTTPRIO;
  FormatSettings : TFormatSettings;
begin
  // cria uma instncia da classe THTTPRIO
  HTTPRIO := THTTPRIO.Create(nil);

  // obtm uma instncia do WSDL
  WebServiceCotacao := GetFachadaWSSGS(True, '', HTTPRIO);

  // customiza o separador de decimais para evitar erro de converso
  FormatSettings.DecimalSeparator := '.';

  // invoca o WebService para buscar a cotao do Dlar do dia
  result := StrToFloat(WebServiceCotacao.getUltimoValorVO(1).ultimoValor.sValor, FormatSettings);
end;

end.
 