unit uSubsystemHistorico;

interface

type
  { Subsystem }
  TSubsystemHistorico = class
  public
    procedure RegistrarHistoricoDoCalculo(const Fidelidade: integer;
      const Dolar, Preco, ValorVenda: real);
  end;

implementation

uses
  SysUtils;

{ TSubsystemHistorico }

procedure TSubsystemHistorico.RegistrarHistoricoDoCalculo(const Fidelidade: integer;
  const Dolar, Preco, ValorVenda: real);
var
  Arquivo: TextFile;
  PathArquivo: string;
  Desconto: string;
begin
  // obtm o caminho e nome do arquivo de histrico
  PathArquivo := ExtractFilePath(ParamStr(0)) + 'Historico.txt';

  // associa a varivel "Arquivo" com o arquivo "Historico.txt"
  AssignFile(Arquivo, PathArquivo);

  if FileExists(PathArquivo) then
    // se o arquivo j existe, coloca-o em modo de edio
    Append(Arquivo)
  else
    // caso contrrio, cria o arquivo
    Rewrite(Arquivo);

  // obtm a descrio do desconto conforme fidelidade
  case Fidelidade of
    0: Desconto := 'Desconto de 2%';
    1: Desconto := 'Desconto de 6%';
    2: Desconto := 'Desconto de 10%';
    3: Desconto := 'Desconto de 18%';
  end;

  // escreve os dados no arquivo "Historico.txt"
  WriteLn(Arquivo, 'Data/Hora.........: ' + FormatDateTime('dd/mm/yyyy - hh:nn:ss', Now));
  WriteLn(Arquivo, 'Cotao do Dlar..: ' + FormatFloat('###,###,##0.00', Dolar));
  WriteLn(Arquivo, 'Converso em R$...: ' + FormatFloat('###,###,##0.00', Dolar * Preco));
  WriteLn(Arquivo, 'Fidelidade........: ' + Desconto);
  WriteLn(Arquivo, 'Margem de venda...: 35%');
  WriteLn(Arquivo, 'Preo final.......: ' + FormatFloat('###,###,##0.00', ValorVenda));
  WriteLn(Arquivo, EmptyStr);

  // fecha o arquivo
  CloseFile(Arquivo);
end;

end.